Index: LMDZ4/branches/V3_test/libf/dyn3dpar/divgrad_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/divgrad_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/divgrad_p.F	(revision 709)
@@ -1,3 +1,3 @@
-      SUBROUTINE divgrad_p (klevel,h, lh, divgra )
+      SUBROUTINE divgrad_p (klevel,h, lh, divgra_out )
       USE parallel
       USE times
@@ -26,5 +26,7 @@
 c
       INTEGER klevel
-      REAL h( ip1jmp1,klevel ), divgra( ip1jmp1,klevel )
+      REAL h( ip1jmp1,klevel ), divgra_out( ip1jmp1,klevel )
+      REAL,SAVE :: divgra( ip1jmp1,llm )
+
 c
       REAL ghy(ip1jm,llm), ghx(ip1jmp1,llm)
@@ -32,6 +34,4 @@
       INTEGER  l,ij,iter,lh
 c
-      EXTERNAL  filtreg
-      EXTERNAL  SCOPY, grad, covcont, diverg
       INTEGER ijb,ije,jjb,jje
 c
@@ -41,6 +41,9 @@
       ijb=ij_begin
       ije=ij_end
-      divgra(ijb:ije,1:klevel)=h(ijb:ije,1:klevel)
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l = 1, klevel      
+      divgra(ijb:ije,l)=h(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT
 c
 
@@ -53,15 +56,21 @@
 
 c      call exchange_Hallo(divgra,ip1jmp1,llm,0,1)
-      
+c$OMP BARRIER
+c$OMP MASTER      
       call suspend_timer(timer_dissip)
       call exchange_Hallo(divgra,ip1jmp1,llm,1,1)
       call resume_timer(timer_dissip)
-       
+c$OMP END MASTER
+c$OMP BARRIER       
       CALL    grad_p (klevel,divgra, ghx  , ghy          )
 
+c$OMP BARRIER
+c$OMP MASTER   
       call suspend_timer(timer_dissip)
       call exchange_Hallo(ghy,ip1jm,llm,1,0)
       call resume_timer(timer_dissip)
-      
+c$OMP END MASTER
+c$OMP BARRIER            
+
       CALL  diverg_p (klevel,  ghx , ghy  , divgra       )
 
@@ -70,9 +79,11 @@
       CALL filtreg_p( divgra,jjb,jje,jjp1,klevel,2,1,.true.,1)
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO 5 l = 1,klevel
       DO 4  ij = ijb, ije
-      divgra( ij,l ) = - cdivh * divgra( ij,l )
+      divgra_out( ij,l ) = - cdivh * divgra( ij,l )
    4  CONTINUE
    5  CONTINUE
+c$OMP END DO NOWAIT
 c
   10  CONTINUE
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/dteta1_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/dteta1_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/dteta1_p.F	(revision 709)
@@ -30,8 +30,5 @@
       REAL hbyv( ip1jm,llm ), hbxu( ip1jmp1,llm )
 
-      EXTERNAL     convflu_p
-      EXTERNAL     filtreg_p
 c
-
       INTEGER ijb,ije,jjb,jje
 
@@ -39,5 +36,6 @@
       jjb=jj_begin
       jje=jj_end
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
       DO 5 l = 1,llm
       
@@ -73,5 +71,5 @@
 	
    5  CONTINUE
-
+c$OMP END DO NOWAIT
        
 	
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/dudv1_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/dudv1_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/dudv1_p.F	(revision 709)
@@ -26,5 +26,5 @@
 c
       
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
       DO 10 l = 1,llm
 c
@@ -60,4 +60,5 @@
 c
   10  CONTINUE
+c$OMP END DO NOWAIT
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/dudv2_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/dudv2_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/dudv2_p.F	(revision 709)
@@ -32,4 +32,5 @@
 c
 c
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO 5 l = 1,llm
 c
@@ -63,4 +64,5 @@
 c
    5  CONTINUE
+c$OMP END DO NOWAIT 
 c
       RETURN
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/dynredem_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/dynredem_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/dynredem_p.F	(revision 709)
@@ -147,5 +147,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"controle",NF_DOUBLE,1,idim_index,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"controle",NF_FLOAT,1,idim_index,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 22,
      .                       "Parametres de controle")
@@ -158,5 +164,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"rlonu",NF_DOUBLE,1,idim_rlonu,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"rlonu",NF_FLOAT,1,idim_rlonu,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 23,
      .                       "Longitudes des points U")
@@ -169,5 +181,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"rlatu",NF_DOUBLE,1,idim_rlatu,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"rlatu",NF_FLOAT,1,idim_rlatu,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 22,
      .                       "Latitudes des points U")
@@ -180,5 +198,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"rlonv",NF_DOUBLE,1,idim_rlonv,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"rlonv",NF_FLOAT,1,idim_rlonv,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 23,
      .                       "Longitudes des points V")
@@ -191,5 +215,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"rlatv",NF_DOUBLE,1,idim_rlatv,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"rlatv",NF_FLOAT,1,idim_rlatv,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 22,
      .                       "Latitudes des points V")
@@ -202,5 +232,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"nivsigs",NF_DOUBLE,1,idim_s,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"nivsigs",NF_FLOAT,1,idim_s,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 28,
      .                       "Numero naturel des couches s")
@@ -213,5 +249,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"nivsig",NF_DOUBLE,1,idim_sig,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"nivsig",NF_FLOAT,1,idim_sig,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 32,
      .                       "Numero naturel des couches sigma")
@@ -224,5 +266,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"ap",NF_DOUBLE,1,idim_sig,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"ap",NF_FLOAT,1,idim_sig,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 26,
      .                       "Coefficient A pour hybride")
@@ -235,5 +283,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"bp",NF_DOUBLE,1,idim_sig,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"bp",NF_FLOAT,1,idim_sig,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 26,
      .                       "Coefficient B pour hybride")
@@ -246,5 +300,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"presnivs",NF_DOUBLE,1,idim_s,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"presnivs",NF_FLOAT,1,idim_s,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
@@ -259,5 +319,11 @@
       dims2(1) = idim_rlonu
       dims2(2) = idim_rlatu
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"cu",NF_DOUBLE,2,dims2,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"cu",NF_FLOAT,2,dims2,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 29,
      .                       "Coefficient de passage pour U")
@@ -272,5 +338,11 @@
       dims2(1) = idim_rlonv
       dims2(2) = idim_rlatv
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"cv",NF_DOUBLE,2,dims2,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"cv",NF_FLOAT,2,dims2,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 29,
      .                       "Coefficient de passage pour V")
@@ -287,5 +359,11 @@
       dims2(1) = idim_rlonv
       dims2(2) = idim_rlatu
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"aire",NF_DOUBLE,2,dims2,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"aire",NF_FLOAT,2,dims2,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 22,
      .                       "Aires de chaque maille")
@@ -302,5 +380,11 @@
       dims2(1) = idim_rlonv
       dims2(2) = idim_rlatu
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"phisinit",NF_DOUBLE,2,dims2,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"phisinit",NF_FLOAT,2,dims2,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 19,
      .                       "Geopotentiel au sol")
@@ -316,5 +400,11 @@
       ierr = NF_REDEF (nid) ! entrer dans le mode de definition
 c
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"temps",NF_DOUBLE,1,idim_tim,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"temps",NF_FLOAT,1,idim_tim,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 19,
      .                       "Temps de simulation")
@@ -329,5 +419,11 @@
       dims4(3) = idim_s
       dims4(4) = idim_tim
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"ucov",NF_DOUBLE,4,dims4,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"ucov",NF_FLOAT,4,dims4,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 9,
      .                       "Vitesse U")
@@ -337,5 +433,11 @@
       dims4(3) = idim_s
       dims4(4) = idim_tim
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"vcov",NF_DOUBLE,4,dims4,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"vcov",NF_FLOAT,4,dims4,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 9,
      .                       "Vitesse V")
@@ -345,5 +447,11 @@
       dims4(3) = idim_s
       dims4(4) = idim_tim
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"teta",NF_DOUBLE,4,dims4,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"teta",NF_FLOAT,4,dims4,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 11,
      .                       "Temperature")
@@ -355,5 +463,11 @@
       IF(nq.GE.1) THEN
       DO iq=1,nq
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,tname(iq),NF_DOUBLE,4,dims4,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,tname(iq),NF_FLOAT,4,dims4,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 12,ttext(iq))
       ENDDO
@@ -364,5 +478,11 @@
       dims4(3) = idim_s
       dims4(4) = idim_tim
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"masse",NF_DOUBLE,4,dims4,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"masse",NF_FLOAT,4,dims4,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 12,
      .                       "C est quoi ?")
@@ -371,5 +491,11 @@
       dims3(2) = idim_rlatu
       dims3(3) = idim_tim
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"ps",NF_DOUBLE,3,dims3,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"ps",NF_FLOAT,3,dims3,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 15,
      .                       "Pression au sol")
@@ -377,4 +503,5 @@
       ierr = NF_ENDDEF(nid) ! sortir du mode de definition
       ierr = NF_CLOSE(nid) ! fermer le fichier
+
 
       PRINT*,'iim,jjm,llm,iday_end',iim,jjm,llm,iday_end
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/enercin_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/enercin_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/enercin_p.F	(revision 709)
@@ -58,5 +58,5 @@
 c              0.5 * V(i,  j)**2 *( alpha2 + alpha3 )
 
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO 5 l = 1,llm
       
@@ -117,4 +117,5 @@
       
    5  CONTINUE
+c$OMP END DO NOWAIT
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/exner_hyb_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/exner_hyb_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/exner_hyb_p.F	(revision 709)
@@ -48,5 +48,5 @@
       REAL xpn, xps
       REAL SSUM
-      EXTERNAL filtreg, SSUM
+      EXTERNAL SSUM
       INTEGER ije,ijb,jje,jjb
 c
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/flumass_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/flumass_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/flumass_p.F	(revision 709)
@@ -37,5 +37,5 @@
       REAL       SSUM
       
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
       DO  5 l = 1,llm
 
@@ -61,5 +61,5 @@
 
    5  CONTINUE
-
+c$OMP END DO NOWAIT
 c    ................................................................
 c     calcul de la composante du flux de masse en x aux poles .......
@@ -87,4 +87,5 @@
         saireun= SSUM( iim, aireu(   1     ), 1 )
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
         DO l = 1,llm
  
@@ -111,5 +112,6 @@
         
         ENDDO
-      
+c$OMP END DO NOWAIT              
+
       ENDIF
 
@@ -119,5 +121,6 @@
         saires = SSUM( iim,  aire( ip1jm+1 ), 1 )
         saireus= SSUM( iim, aireu( ip1jm+1 ), 1 )
-        
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
         DO  l = 1,llm
  
@@ -143,5 +146,5 @@
        
         ENDDO
-         
+c$OMP END DO NOWAIT         
       ENDIF
       
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/fluxstokenc_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/fluxstokenc_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/fluxstokenc_p.F	(revision 709)
@@ -39,5 +39,5 @@
       real tst(1),ist(1),istp(1)
       INTEGER ij,l,irec,i,j,itau
-      INTEGER fluxid, fluxvid,fluxdid
+      INTEGER,SAVE :: fluxid, fluxvid,fluxdid
  
       SAVE iadvtr, massem,pbaruc,pbarvc,irec
@@ -49,4 +49,9 @@
       integer :: ijb,ije,jjb,jje,jjn
       type(Request) :: Req
+
+c AC initialisations
+cym      pbarug(:,:)   = 0.
+cym      pbarvg(:,:,:) = 0.
+cym      wg(:,:)       = 0.
 
       if(first) then
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/fxhyp.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/fxhyp.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/fxhyp.F	(revision 709)
@@ -4,5 +4,5 @@
 c
 c
-       SUBROUTINE fxhyp ( xzoomdeg,grossism,dzoom,tau ,
+       SUBROUTINE fxhyp ( xzoomdeg,grossism,dzooma,tau ,
      , rlonm025,xprimm025,rlonv,xprimv,rlonu,xprimu,rlonp025,xprimp025,
      , champmin,champmax                                               )
@@ -38,5 +38,5 @@
 c     ......  arguments  d'entree   .......
 c
-       REAL xzoomdeg,dzoom,tau,grossism
+       REAL xzoomdeg,dzooma,tau,grossism
 
 c    ......   arguments  de  sortie  ......
@@ -47,4 +47,5 @@
 c     .... variables locales  ....
 c
+       REAL   dzoom
        REAL*8 xlon(iip1),xprimm(iip1),xuv
        REAL*8 xtild(0:nmax2)
@@ -74,12 +75,12 @@
        WRITE(6,*) 'FXHYP scal180,decalx', scal180,decalx
 c
-       IF( dzoom.LT.1.)  THEN
-         dzoom = dzoom * depi
-       ELSEIF( dzoom.LT. 25. ) THEN
-         WRITE(6,*) ' Le param. dzoomy pour fxhyp est trop petit ! L aug
+       IF( dzooma.LT.1.)  THEN
+         dzoom = dzooma * depi
+       ELSEIF( dzooma.LT. 25. ) THEN
+         WRITE(6,*) ' Le param. dzoomx pour fxhyp est trop petit ! L aug
      ,menter et relancer ! '
          STOP 1
        ELSE
-         dzoom = dzoom * pi/180.
+         dzoom = dzooma * pi/180.
        ENDIF
 
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/fyhyp.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/fyhyp.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/fyhyp.F	(revision 709)
@@ -4,5 +4,5 @@
 c
 c
-       SUBROUTINE fyhyp ( yzoomdeg, grossism, dzoom,tau  ,  
+       SUBROUTINE fyhyp ( yzoomdeg, grossism, dzooma,tau  ,  
      ,  rrlatu,yyprimu,rrlatv,yyprimv,rlatu2,yprimu2,rlatu1,yprimu1 ,
      ,  champmin,champmax                                            ) 
@@ -37,5 +37,5 @@
 c     .......  arguments  d'entree    .......
 c
-       REAL yzoomdeg, grossism,dzoom,tau 
+       REAL yzoomdeg, grossism,dzooma,tau 
 c         ( rentres  par  run.def )
 
@@ -49,4 +49,5 @@
 c
      
+       REAL   dzoom
        REAL*8 ylat(jjp1), yprim(jjp1)
        REAL*8 yuv
@@ -78,12 +79,12 @@
        y0       =  yzoomdeg * pi/180. 
 
-       IF( dzoom.LT.1.)  THEN
-         dzoom = dzoom * pi
-       ELSEIF( dzoom.LT. 12. ) THEN
+       IF( dzooma.LT.1.)  THEN
+         dzoom = dzooma * pi
+       ELSEIF( dzooma.LT. 12. ) THEN
          WRITE(6,*) ' Le param. dzoomy pour fyhyp est trop petit ! L aug
      ,menter et relancer ! '
          STOP 1
        ELSE
-         dzoom = dzoom * pi/180.
+         dzoom = dzooma * pi/180.
        ENDIF
 
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/gcm.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/gcm.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/gcm.F	(revision 709)
@@ -119,7 +119,4 @@
       REAL      d_h_vcol, d_qt, d_qw, d_ql, d_ec
       CHARACTER*15 ztit
-      INTEGER   ip_ebil_dyn  ! PRINT level for energy conserv. diag.
-      SAVE      ip_ebil_dyn
-      DATA      ip_ebil_dyn/0/
 c-jld 
 
@@ -208,4 +205,5 @@
       call InitDimphy
       call InitBands
+      call MPI_BARRIER(COMM_LMDZ,ierr)
       if (mpi_rank==0) call WriteBands
       call SetDistrib(jj_Nb_Caldyn)
@@ -218,7 +216,8 @@
       enddo
       call Init_Mod_hallo(MPI_Buffer)
-
+c$OMP PARALLEL
+      call init_phys_openmp
       call InitComgeomphy
-
+c$OMP END PARALLEL 
 #ifdef INCA
       call init_inca_dim
@@ -362,6 +361,8 @@
          WRITE(lunout,*)
      .           'WARNING!!! vitesse verticale nulle dans la physique'
+
          CALL iniphysiq(ngridmx,llm,daysec,day_ini,dtphys ,
      ,                latfi,lonfi,airefi,zcufi,zcvfi,rad,g,r,cpp     )
+
          call_iniphys=.false.
       ENDIF
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/gr_dyn_fi_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/gr_dyn_fi_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/gr_dyn_fi_p.F	(revision 709)
@@ -1,4 +1,5 @@
       SUBROUTINE gr_dyn_fi_p(nfield,im,jm,ngrid,pdyn,pfi)
       USE dimphy
+      USE PARALLEL
       IMPLICIT NONE
 c=======================================================================
@@ -14,5 +15,5 @@
       REAL pfi(ngrid,nfield)
 
-      INTEGER i,j,ig
+      INTEGER i,j,ig,l
 
 c-----------------------------------------------------------------------
@@ -23,12 +24,13 @@
 c   traitement des poles
 c   traitement des point normaux
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l=1,nfield    
        DO ig=1,klon
          i=Liste_i(ig)
          j=Liste_j(ig)
-         pfi(ig,1:nfield)=pdyn(i,j,1:nfield)
+         pfi(ig,l)=pdyn(i,j,l)
        ENDDO
-
-
+      ENDDO
+c$OMP END DO NOWAIT
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/gr_fi_dyn_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/gr_fi_dyn_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/gr_fi_dyn_p.F	(revision 709)
@@ -20,5 +20,5 @@
 c   calcul:
 c   -------
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO ifield=1,nfield
 
@@ -44,5 +44,5 @@
       
       ENDDO
-
+c$OMP END DO NOWAIT
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/grad_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/grad_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/grad_p.F	(revision 709)
@@ -22,4 +22,5 @@
 c
 c
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO 6 l = 1,klevel
 c
@@ -47,4 +48,6 @@
 c
    6  CONTINUE
+c$OMP END DO NOWAIT
+
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/gradiv2_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/gradiv2_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/gradiv2_p.F	(revision 709)
@@ -1,3 +1,3 @@
-      SUBROUTINE gradiv2_p(klevel, xcov, ycov, ld, gdx, gdy )
+      SUBROUTINE gradiv2_p(klevel, xcov, ycov, ld, gdx_out, gdy_out )
 c
 c     P. Le Van
@@ -27,9 +27,10 @@
       INTEGER klevel
       REAL  xcov( ip1jmp1,klevel ), ycov( ip1jm,klevel )
-      REAL   gdx( ip1jmp1,klevel ),  gdy( ip1jm,klevel )
+      REAL,SAVE ::  gdx( ip1jmp1,llm ),  gdy( ip1jm,llm )
+      REAL   gdx_out( ip1jmp1,klevel ), gdy_out( ip1jm,klevel )
 c
 c     ........       variables locales       .........
 c
-      REAL div(ip1jmp1,llm)
+      REAL,SAVE :: div(ip1jmp1,llm)
       REAL signe, nugrads
       INTEGER l,ij,iter,ld
@@ -38,5 +39,4 @@
 c    ........................................................
 c
-      EXTERNAL   SCOPY, divergf, grad, laplacien_gam, filtreg
 c
 c      CALL SCOPY( ip1jmp1 * klevel, xcov, 1, gdx, 1 )
@@ -45,15 +45,28 @@
       ijb=ij_begin
       ije=ij_end
-      gdx(ijb:ije,1:klevel)=xcov(ijb:ije,1:klevel)
-
+      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO   l = 1, klevel
+        gdx(ijb:ije,l)=xcov(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT      
       
       ijb=ij_begin
       ije=ij_end
       if(pole_sud) ije=ij_end-iip1
-      gdy(ijb:ije,1:klevel)=ycov(ijb:ije,1:klevel)
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+      DO   l = 1, klevel
+        gdy(ijb:ije,l)=ycov(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT
+
+c$OMP BARRIER
+c$OMP MASTER      
       call suspend_timer(timer_dissip)
       call exchange_Hallo(gdy,ip1jm,llm,1,0)
       call resume_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
 c
 c
@@ -67,9 +80,11 @@
 
       IF( ld.GT.1 )   THEN
-        
+c$OMP BARRIER
+c$OMP MASTER        
 	call suspend_timer(timer_dissip)
         call exchange_Hallo(div,ip1jmp1,llm,1,1)
         call resume_timer(timer_dissip)
-        
+c$OMP END MASTER        
+c$OMP BARRIER
 	CALL laplacien_p ( klevel, div,  div     )
 
@@ -78,7 +93,11 @@
 
         DO iter = 1, ld -2
+c$OMP BARRIER
+c$OMP MASTER
 	 call suspend_timer(timer_dissip)
          call exchange_Hallo(div,ip1jmp1,llm,1,1)
 	 call resume_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
          CALL laplacien_gam ( klevel,cuvscvgam1,cvuscugam1,unsair_gam1,
      *                       unsapolnga1, unsapolsga1,  div, div       )
@@ -92,9 +111,11 @@
        CALL filtreg_p( div   ,jjb,jje, jjp1, klevel, 2, 1, .TRUE., 1 )
 c       call exchange_Hallo(div,ip1jmp1,llm,0,1)
-        
+c$OMP BARRIER
+c$OMP MASTER        
 	call suspend_timer(timer_dissip)
 	call exchange_Hallo(div,ip1jmp1,llm,1,1)
         call resume_timer(timer_dissip)
-
+c$OMP END MASTER
+c$OMP BARRIER
 c       call write_field3d_p('div4',reshape(div,(/iip1,jjp1,llm/)))
        CALL  grad_p  ( klevel,  div,   gdx,  gdy             )
@@ -104,18 +125,19 @@
       ije=ij_end
          
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
        DO   l = 1, klevel
          
          if (pole_sud) ije=ij_end
          DO  ij = ijb, ije
-          gdx( ij,l ) = gdx( ij,l ) * nugrads
+          gdx_out( ij,l ) = gdx( ij,l ) * nugrads
          ENDDO
          
          if (pole_sud) ije=ij_end-iip1
          DO  ij = ijb, ije
-          gdy( ij,l ) = gdy( ij,l ) * nugrads
+          gdy_out( ij,l ) = gdy( ij,l ) * nugrads
          ENDDO
        
        ENDDO
+c$OMP END DO NOWAIT
 c
        RETURN
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/gradiv_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/gradiv_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/gradiv_p.F	(revision 709)
@@ -1,3 +1,3 @@
-      SUBROUTINE gradiv_p(klevel, xcov, ycov, ld, gdx, gdy )
+      SUBROUTINE gradiv_p(klevel, xcov, ycov, ld, gdx_out, gdy_out )
 c
 c    Auteur :   P. Le Van
@@ -26,12 +26,12 @@
 c
       REAL xcov( ip1jmp1,klevel ), ycov( ip1jm,klevel )
-      REAL gdx( ip1jmp1,klevel ),   gdy( ip1jm,klevel )
+      REAL,SAVE :: gdx( ip1jmp1,llm ),   gdy( ip1jm,llm )
 
-      REAL div(ip1jmp1,llm)
+      REAL gdx_out( ip1jmp1,klevel ),   gdy_out( ip1jm,klevel )
+
+      REAL,SAVE ::  div(ip1jmp1,llm)
 
       INTEGER l,ij,iter,ld
 c
-      EXTERNAL   SCOPY, diverg,  grad
-      EXTERNAL   filtreg
       INTEGER ijb,ije,jjb,jje
 c
@@ -42,18 +42,32 @@
       ijb=ij_begin
       ije=ij_end
-      gdx(ijb:ije,1:klevel)=xcov(ijb:ije,1:klevel)
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+      DO l = 1,klevel
+        gdx(ijb:ije,l)=xcov(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT
+      
       ijb=ij_begin
       ije=ij_end
       if(pole_sud) ije=ij_end-iip1
-      gdy(ijb:ije,1:klevel)=ycov(ijb:ije,1:klevel)
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+      DO l = 1,klevel
+        gdy(ijb:ije,l)=ycov(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT
+
 c
       DO 10 iter = 1,ld
-      
+
+c$OMP BARRIER
+c$OMP MASTER      
       call suspend_timer(timer_dissip)
       call exchange_Hallo(gdy,ip1jm,llm,1,0)
       call resume_timer(timer_dissip)
-      
+c$OMP END MASTER      
+c$OMP BARRIER
+
       CALL  diverg_p( klevel,  gdx , gdy, div          )
       
@@ -63,24 +77,31 @@
       
 c      call exchange_Hallo(div,ip1jmp1,llm,0,1)
-      
+
+c$OMP BARRIER
+c$OMP MASTER       
       call suspend_timer(timer_dissip)
       call exchange_Hallo(div,ip1jmp1,llm,1,1)
       call resume_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
       
       CALL    grad_p( klevel,  div, gdx, gdy           )
 c
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO 5  l = 1, klevel
       
       if(pole_sud) ije=ij_end
       DO 3 ij = ijb, ije
-        gdx( ij,l ) = - gdx( ij,l ) * cdivu
+        gdx_out( ij,l ) = - gdx( ij,l ) * cdivu
    3  CONTINUE
    
       if(pole_sud) ije=ij_end-iip1
       DO 4 ij = ijb, ije
-        gdy( ij,l ) = - gdy( ij,l ) * cdivu
+        gdy_out( ij,l ) = - gdy( ij,l ) * cdivu
    4  CONTINUE
 
    5  CONTINUE
+c$OMP END DO NOWAIT
 c
   10  CONTINUE
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/gradsdef.h
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/gradsdef.h	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/gradsdef.h	(revision 709)
@@ -3,5 +3,5 @@
 !
       integer nfmx,imx,jmx,lmx,nvarmx
-      parameter(nfmx=10,imx=200,jmx=150,lmx=20,nvarmx=1000)
+      parameter(nfmx=10,imx=200,jmx=150,lmx=200,nvarmx=1000)
 
       real xd(imx,nfmx),yd(jmx,nfmx),zd(lmx,nfmx),dtime(nfmx)
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/grid_noro.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/grid_noro.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/grid_noro.F	(revision 709)
@@ -53,4 +53,5 @@
 c             zval:  Minimum altitude
 C=======================================================================
+
       IMPLICIT INTEGER (I,J)
       IMPLICIT REAL(X,Z) 
@@ -79,4 +80,5 @@
       REAL x(imar+1),y(jmar),zphi(imar+1,jmar)
       REAL zmea(imar+1,jmar),zstd(imar+1,jmar)
+      REAL zmea0(imar+1,jmar) ! GK211005 (CG)
       REAL zsig(imar+1,jmar),zgam(imar+1,jmar),zthe(imar+1,jmar)
       REAL zpic(imar+1,jmar),zval(imar+1,jmar)
@@ -309,4 +311,5 @@
 C  FIRST FILTER, MOVING AVERAGE OVER 9 POINTS.
 
+       zmea0(:,:) = zmea(:,:) ! GK211005 (CG) on sauvegarde la topo non lissee
        CALL MVA9(zmea,iim+1,jjm+1)
        CALL MVA9(zstd,iim+1,jjm+1)
@@ -353,5 +356,8 @@
 c angle theta:
            zthe(ii,jj)=57.29577951*atan2(xm,xl)/2.*mask_tmp(ii,jj)
-           zphi(ii,jj)=zmea(ii,jj)*mask_tmp(ii,jj)
+           ! GK211005 (CG) ne pas forcement lisser la topo
+           ! zphi(ii,jj)=zmea(ii,jj)*mask_tmp(ii,jj)
+           zphi(ii,jj)=zmea0(ii,jj)*mask_tmp(ii,jj)
+           !
            zmea(ii,jj)=zmea(ii,jj)*mask_tmp(ii,jj)
            zpic(ii,jj)=zpic(ii,jj)*mask_tmp(ii,jj)
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/grilles_gcm_netcdf.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/grilles_gcm_netcdf.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/grilles_gcm_netcdf.F	(revision 709)
@@ -73,6 +73,6 @@
 
       do i=1,iip1
-         rlonudeg(i)=rlonu(i)*180./pi
-         rlonvdeg(i)=rlonv(i)*180./pi
+         rlonudeg(i)=rlonu(i)*180./pi + 360.
+         rlonvdeg(i)=rlonv(i)*180./pi + 360.
       enddo
 
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/groupe_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/groupe_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/groupe_p.F	(revision 709)
@@ -30,5 +30,6 @@
       real wm(iip1,jjp1,llm)
 
-      real zconvm(iip1,jjp1,llm),zconvmm(iip1,jjp1,llm)
+      real,save :: zconvm(iip1,jjp1,llm)
+      real,save :: zconvmm(iip1,jjp1,llm)
 
       real uu
@@ -38,4 +39,5 @@
       logical firstcall
       save firstcall
+c$OMP THREADPRIVATE(firstcall)
 
       data firstcall/.true./
@@ -57,5 +59,11 @@
       jjb=jj_begin
       jje=jj_end
-      zconvmm(:,jjb:jje,:)=zconvm(:,jjb:jje,:)
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+      do l=1,llm
+        zconvmm(:,jjb:jje,l)=zconvm(:,jjb:jje,l)
+      enddo
+c$OMP END DO NOWAIT
+
       call groupeun_p(jjp1,llm,jjb,jje,zconvmm)
       
@@ -64,5 +72,10 @@
       if (pole_nord) jjb=jj_begin
       if (pole_sud)  jje=jj_end-1
-      pbarvm(:,jjb:jje,:)=pbarv(:,jjb:jje,:)
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+      do l=1,llm
+        pbarvm(:,jjb:jje,l)=pbarv(:,jjb:jje,l)
+      enddo
+c$OMP END DO NOWAIT
+
       call groupeun_p(jjm,llm,jjb,jje,pbarvm)
 
@@ -74,4 +87,5 @@
       if (pole_sud)  jje=jj_end-1
       
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       do l=1,llm
          do j=jjb,jje
@@ -86,18 +100,12 @@
          enddo
       enddo
-
+c$OMP END DO NOWAIT
 c    integration de la convergence de masse de haut  en bas ......
    
       jjb=jj_begin
       jje=jj_end
-      
-      do l=1,llm
-         do j=jjb,jje
-            do i=1,iip1
-               zconvmm(i,j,l)=zconvmm(i,j,l)
-            enddo
-         enddo
-      enddo
-      
+
+c$OMP BARRIER
+c$OMP MASTER      
       do  l = llm-1,1,-1
           do j=jjb,jje
@@ -107,9 +115,13 @@
           enddo
       enddo
-      
+
       if (.not. pole_sud) then
         zconvmm(:,jj_end+1,:)=0
-	wm(:,jj_end+1,:)=0
+cym	wm(:,jj_end+1,:)=0
       endif
+      
+c$OMP END MASTER
+c$OMP BARRIER      
+
       CALL vitvert_p(zconvmm(1,1,1),wm(1,1,1))
 
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/groupeun_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/groupeun_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/groupeun_p.F	(revision 709)
@@ -21,4 +21,5 @@
 Champs 3D
       jd=jjp1-jjmax
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       do l=1,llm
       j1=1+jd
@@ -72,5 +73,5 @@
       enddo
       enddo
-
+c$OMP END DO NOWAIT
       return
       end
